SystemOrganization addCategory: #ConfigurationOfTimFelgentreff!

Object subclass: #ConfigurationOfTimFelgentreff
	instanceVariableNames: 'project selected'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfTimFelgentreff'!

!ConfigurationOfTimFelgentreff class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:57:01.078'!
allWindowsDo: aBlock

	SystemWindow subclasses
		collect: [:k | k allInstances]
		thenDo: [:iary | iary do: aBlock].! !

!ConfigurationOfTimFelgentreff class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:55:47.316'!
applyCustomizations

	MCMcmUpdater updateFromDefaultRepository.
	World color: Preferences defaultWorldColor.
	self hideWindows.
! !

!ConfigurationOfTimFelgentreff class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfTimFelgentreff class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfTimFelgentreff class methodsFor: 'private' stamp: 'tfel 2/2/2012 11:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfTimFelgentreff class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:56:38.144'!
hideWindows

	self allWindowsDo: [:window | window hide].! !

!ConfigurationOfTimFelgentreff class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:58:31.93'!
install
	self
		applyCustomizations;
		provideConfigurations.! !

!ConfigurationOfTimFelgentreff class methodsFor: 'metacello tool support' stamp: 'tfel 2/2/2012 11:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfTimFelgentreff class methodsFor: 'accessing' stamp: 'tfel 2/2/2012 11:12'!
project

	^self new project! !

!ConfigurationOfTimFelgentreff class methodsFor: 'actions' stamp: 'tfel 2/22/2012 16:01:17.433'!
provideConfigurations

	| groups instance mm |
	instance := self new.
	groups := self project bleedingEdge groups collect: [:group | group name].
	mm := MenuMorph new
		stayUp: true;
		target: instance;
		yourself.
	groups do: [:name |
		mm addUpdating: ('IsSelected', name) asSymbol action: ('ToggleSelect', name) asSymbol].
	mm
		addLine;
		add: 'Install'
		target: [
			mm abandon.
			self project bleedingEdge load: instance selected asArray]
		selector: #value
		argumentList: #().
	mm
		center: ActiveHand center;
		openInWorld.! !

!ConfigurationOfTimFelgentreff class methodsFor: 'actions' stamp: 'tfel 2/22/2012 15:56:43.091'!
showWindows

	self allWindowsDo: [:window | window show].! !

!ConfigurationOfTimFelgentreff class methodsFor: 'development support' stamp: 'tfel 2/2/2012 11:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfTimFelgentreff methodsFor: 'private' stamp: 'tfel 2/2/2012 13:47'!
addProjects: aListOfSpecs to: spec inVersion: versionString

	aListOfSpecs do: [:array || name url deps configs projects | "groupname [url] [deps] [configs]"
			name := array first.
			url := (array at: 2 ifAbsent: []) ifNil: ['http://www.squeaksource.com/MetacelloRepository'].
			deps := (array at: 3 ifAbsent: []) ifNil: [#()].
			configs := (array at: 4 ifAbsent: []) ifNil: [{name. #('default')}].
			projects := deps asOrderedCollection.
			
			configs pairsDo: [:projectname :loads |
				projects add: 'Project', projectname.
				spec project: projects last with: [
					spec
						className: 'ConfigurationOf', projectname;
						file: 'ConfigurationOf', projectname;
						repository: url;
						loads: loads;
						versionString: versionString]].
			spec group: name with: projects].! !

!ConfigurationOfTimFelgentreff methodsFor: 'baselines' stamp: 'tfel 2/2/2012 13:42'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/timfelgentreff'.
		self
			addProjects: self myProjects to: spec inVersion: #bleedingEdge;
			addProjects: self otherProjects to: spec inVersion: #stable].
! !

!ConfigurationOfTimFelgentreff methodsFor: 'error handling' stamp: 'tfel 2/2/2012 14:07'!
doesNotUnderstand: aMessage

	(aMessage selector asString beginsWith: 'IsSelected') ifTrue: [| name |
		name := (aMessage selector asString copyReplaceAll: 'IsSelected' with: '').
		^ self packageIsSelected: name].
	(aMessage selector asString beginsWith: 'ToggleSelect') ifTrue: [| name |
		name := (aMessage selector asString copyReplaceAll: 'ToggleSelect' with: '').
		^ self togglePackage: name].

	^ super doesNotUnderstand: aMessage! !

!ConfigurationOfTimFelgentreff methodsFor: 'initialize-release' stamp: 'tfel 2/2/2012 14:08'!
initialize

	super initialize.
	self selected: OrderedCollection new.
! !

!ConfigurationOfTimFelgentreff methodsFor: 'specs' stamp: 'tfel 2/2/2012 13:31'!
myProjects 
	"groupname [url] [deps] [configs]"
 	^ #(
		#('RatPack')
		#('PathTools' 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/masterproject2011')
		#('Gitocello')
	)
! !

!ConfigurationOfTimFelgentreff methodsFor: 'specs' stamp: 'tfel 2/22/2012 15:59:30.782'!
otherProjects 
	"groupname [url] [deps] [configs]"
 	^ #(
			#('MetacelloBrowser' 'http://www.squeaksource.com/MetacelloBrowser/')
			#('OmniBrowser' nil #() #('OmniBrowser' #('Dev')))
			#('Seaside' nil #('OmniBrowser') #('Seaside30' #() 'Magritte2' #('Magritte-Seaside')))
	)! !

!ConfigurationOfTimFelgentreff methodsFor: 'actions' stamp: 'tfel 2/2/2012 14:06'!
packageIsSelected: name

	^ ((self selected includes: name)
			ifTrue: ['<yes>']
			ifFalse: ['<no>']), name! !

!ConfigurationOfTimFelgentreff methodsFor: 'accessing' stamp: 'tfel 2/2/2012 11:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfTimFelgentreff methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
project: anObject
	"Set the value of project"

	project := anObject! !

!ConfigurationOfTimFelgentreff methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
selected
	"Answer the value of selected"

	^ selected! !

!ConfigurationOfTimFelgentreff methodsFor: 'accessing' stamp: 'tfel 2/2/2012 14:08'!
selected: anObject
	"Set the value of selected"

	selected := anObject! !

!ConfigurationOfTimFelgentreff methodsFor: 'actions' stamp: 'tfel 2/2/2012 14:18'!
togglePackage: name

	^ (self selected includes: name)
			ifTrue: [self selected remove: name]
			ifFalse: [self selected add: name]! !
